package demo.barcharts.category ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.awt.Paint ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.marker.CategoryMarker ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.ui.Layer ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BarChartDemo3 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public BarChartDemo3() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createCategoryBar2DChart(
      "Bar Chart Demo 3", "Category", "Score (%)", dataset, orientation, false, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    Bar2DRender render = (Bar2DRender) plot.getRender() ;
    render.setBaseItemLabelVisible(true) ;

    Paint paints[] = {new Color(196, 215, 216), new Color(78, 137, 139), new Color(138, 177, 178),
                     new Color(19, 97, 100)
    } ;

    render.setAutoSelectFillPaint(false) ;
    for (int i = 0 ; i < paints.length ; i++) {
      render.setColumnItemFillPaint(i, paints[i]) ;
    }

    CategoryMarker marker = new CategoryMarker("Category 3") ;
    marker.setText("Special") ;
    marker.setFillPaint(new Color(221, 255, 221, 128)) ;
    marker.setFillAlpha(0.5F) ;
    marker.setTextHorizontalAlign(HorizontalAlignment.LEFT) ;
    marker.setTextVerticalAlign(VerticalAlignment.TOP) ;
    plot.getCategoryAxis().addCategoryMarker(Layer.BACKGROUND, marker) ;

    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    NumberValueAxis numberaxis1 = new NumberValueAxis(dataset) ;
    numberaxis1.setTickUnit(new LongTickUnit()) ;
    plot.setValueAxis(1, numberaxis1) ;

    CategoryAxis categoryaxis = new CategoryAxis(dataset) ;
    plot.setCategoryAxis(1, categoryaxis) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Category 1") ;
    dataset.addRowKey("Category 2") ;
    dataset.addRowKey("Category 3") ;
    dataset.addRowKey("Category 4") ;
    dataset.addRowKey("Category 5") ;

    dataset.addColKey("Series 1") ;

    double data[][] = { {4D, 3D, -2D, 3D, 6D}
    } ;
    dataset.addRowData(5) ;

    for (int i = 0 ; i < 5 ; i++) {
      for (int j = 0 ; j < data.length ; j++) {
        dataset.addData(i, new NumberChartData(data[j][i])) ;
      }
    }

    return dataset ;
  }

}
