package demo.barcharts.category ;

import java.awt.Color ;
import java.awt.GradientPaint ;
import java.awt.GridLayout ;
import java.awt.Paint ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.GradientPaintTransformType ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class CylinderChartDemo2 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.HORIZONTAL ;

  public CylinderChartDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createCylinderChart(
      "Cylinder Chart Demo 2", "Category", "Value", dataset, orientation, false, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    Paint paints[] = createPaint() ;
    Bar2DRender render = (Bar2DRender) plot.getRender() ;
    render.setAutoSelectFillPaint(false) ;
    for (int i = 0 ; i < 5 ; i++) {
      render.setRowItemFillPaint(i, paints[i]) ;
      render.setRowItemFillPaintTransformer(i, GradientPaintTransformType.CENTER_VERTICAL) ;
    }

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static Paint[] createPaint() {
    Paint apaint[] = new Paint[5] ;
    apaint[0] = new GradientPaint(0.0F, 0.0F, Color.white, 0.0F, 0.0F, Color.red) ;
    apaint[1] = new GradientPaint(0.0F, 0.0F, Color.white, 0.0F, 0.0F, Color.green) ;
    apaint[2] = new GradientPaint(0.0F, 0.0F, Color.white, 0.0F, 0.0F, Color.blue) ;
    apaint[3] = new GradientPaint(0.0F, 0.0F, Color.white, 0.0F, 0.0F, Color.orange) ;
    apaint[4] = new GradientPaint(0.0F, 0.0F, Color.white, 0.0F, 0.0F, Color.magenta) ;
    return apaint ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowKey("Monday") ;
    dataset.addRowKey("Tuesday") ;
    dataset.addRowKey("Wednesday") ;
    dataset.addRowKey("Thursday") ;
    dataset.addRowKey("Friday") ;
    dataset.addColKey("S1") ;

    double data[] = {4D, 5D, -7D, 6D, 4D} ;
    dataset.addRowData(data.length) ;

    for (int j = 0 ; j < data.length ; j++) {
      dataset.addData(j, new NumberChartData(data[j])) ;
    }

    return dataset ;
  }

}
