package demo.barcharts.category ;

import java.awt.GridLayout ;
import java.text.NumberFormat ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.IntervalValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.IFormatter ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.range.NumberRange ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class IntervalBarChartDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  private final NumberFormat format = NumberFormat.getPercentInstance() ;

  public IntervalBarChartDemo1() {
    format.setMinimumFractionDigits(2) ;
    format.setMaximumFractionDigits(2) ;
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createIntervalBarChart(
      "IntervalBarChartDemo1", "Category", "Percentage", dataset, orientation, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    IntervalValueAxis valueAxis = (IntervalValueAxis) plot.getValueAxis() ;
    valueAxis.setUserDefineDatasetRange(new NumberRange(0, 0.9)) ;
    valueAxis.setTickValueFormatter(new IFormatter() {
      public String format(Object obj, int index) {
        String str = obj.toString() ;
        String tick = format.format(Double.parseDouble(str)) ;
        return tick ;
      }
    }) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Category 1") ;
    dataset.addRowKey("Category 2") ;
    dataset.addRowKey("Category 3") ;

    for (int i = 1 ; i <= 2 ; i++) {
      dataset.addColKey("Series " + i) ;
    }

    dataset.addRowData(3) ;
    dataset.addData(0, new IntervalChartData(0.10000000000000001D, 0.5D)) ;
    dataset.addData(0, new IntervalChartData(0.29999999999999999D, 0.69999999999999996D)) ;

    dataset.addData(1, new IntervalChartData(0.20000000000000001D, 0.59999999999999998D)) ;
    dataset.addData(1, new IntervalChartData(0.40000000000000002D, 0.80000000000000004D)) ;

    dataset.addData(2, new IntervalChartData(0.29999999999999999D, 0.69999999999999996D)) ;
    dataset.addData(2, new IntervalChartData(0.5D, 0.90000000000000002D)) ;

    return dataset ;
  }

}
