package demo.barcharts.xy ;

import java.awt.Color ;
import java.awt.GradientPaint ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.IntervalXYValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.DateTickUnitType ;
import com.ijchart.xychart.constant.GradientPaintTransformType ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYClusteredBar2DRender ;
import com.ijchart.xychart.tickunit.DateTickUnit ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ClusteredXYBarRendererDemo1 extends JPanel {

  private IMatrixDataset dataset ;

  public ClusteredXYBarRendererDemo1() {
    dataset = createDataset() ;
    setLayout(new GridLayout(2, 2)) ;
    addPanel() ;
  }

  private void addPanel() {
    IJChart chart = createChart("Vertical", ChartOrientation.VERTICAL) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    XYClusteredBar2DRender render = (XYClusteredBar2DRender) xyplot.getRender() ;
    render.setRowItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                    Color.yellow)) ;
    render.setRowItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                    Color.green)) ;
    render.setBaseItemFillPaintTransformer(GradientPaintTransformType.VERTICAL) ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;

    IJChart chart1 = createChart("Vertical / Inverted Axis", ChartOrientation.VERTICAL) ;
    XYPlot xyplot1 = (XYPlot) chart1.getPlot() ;
    XYClusteredBar2DRender render1 = (XYClusteredBar2DRender) xyplot1.getRender() ;
    render1.setRowItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                     Color.yellow)) ;
    render1.setRowItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                     Color.green)) ;
    render1.setBaseItemFillPaintTransformer(GradientPaintTransformType.HORIZONTAL) ;
    xyplot1.getDomainAxis().setInverted(true) ;
    ChartPanel chartpanel1 = new ChartPanel(chart1) ;
    add(chartpanel1) ;

    IJChart chart2 = createChart("Horizontal", ChartOrientation.HORIZONTAL) ;
    XYPlot xyplot2 = (XYPlot) chart2.getPlot() ;
    XYClusteredBar2DRender render2 = (XYClusteredBar2DRender) xyplot2.getRender() ;
    render2.setRowItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                     Color.yellow)) ;
    render2.setRowItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                     Color.green)) ;
    render2.setBaseItemFillPaintTransformer(GradientPaintTransformType.CENTER_VERTICAL) ;
    ChartPanel chartpanel2 = new ChartPanel(chart2) ;
    add(chartpanel2) ;

    IJChart chart3 = createChart("Horizontal / Inverted Axis", ChartOrientation.HORIZONTAL) ;
    XYPlot xyplot3 = (XYPlot) chart3.getPlot() ;
    XYClusteredBar2DRender render3 = (XYClusteredBar2DRender) xyplot3.getRender() ;
    render3.setRowItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                     Color.yellow)) ;
    render3.setRowItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                     Color.green)) ;
    render3.setBaseItemFillPaintTransformer(GradientPaintTransformType.CENTER_HORIZONTAL) ;
    xyplot3.getDomainAxis().setInverted(true) ;
    ChartPanel chartpanel3 = new ChartPanel(chart3) ;
    add(chartpanel3) ;
  }

  private IJChart createChart(String title, ChartOrientation orientation) {
    IJChart chart = ChartFactory.createClusteredXYBar2DChart(
      title, null, "Y", dataset, orientation, true, false, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    IntervalXYValueAxis valueAxis = (IntervalXYValueAxis) xyplot.getDomainAxis() ;
    valueAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_DAY)) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData(2) ;

    dataset.addData(0, new IntervalXYNumberChartData(toMills(1, 1, 2003),
                                                     toMills(2, 1, 2003), 0, 54.299999999999997D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(toMills(2, 1, 2003),
                                                     toMills(3, 1, 2003), 0, 20.300000000000001D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(toMills(3, 1, 2003),
                                                     toMills(4, 1, 2003), 0, 43.399999999999999D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(toMills(4, 1, 2003),
                                                     toMills(5, 1, 2003), 0, -12D)) ;

    dataset.addData(1, new IntervalXYNumberChartData(toMills(1, 1, 2003),
                                                     toMills(2, 1, 2003), 0, 8D)) ;
    dataset.addData(1, new IntervalXYNumberChartData(toMills(2, 1, 2003),
                                                     toMills(3, 1, 2003), 0, 16D)) ;
    dataset.addData(1, new IntervalXYNumberChartData(toMills(3, 1, 2003),
                                                     toMills(4, 1, 2003), 0, 21D)) ;
    dataset.addData(1, new IntervalXYNumberChartData(toMills(4, 1, 2003),
                                                     toMills(5, 1, 2003), 0, 5D)) ;

    return dataset ;
  }

  private static long toMills(int day, int month, int year) {
    return DateUtil.dateToTimeInMillis(year, month, day) ;
  }
}
