package demo.images ;

import java.awt.Color ;
import java.awt.GradientPaint ;

import com.ijchart.xychart.axis.value.IntervalXYValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.DateTickUnitType ;
import com.ijchart.xychart.constant.GradientPaintTransformType ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYClusteredBar2DRender ;
import com.ijchart.xychart.tickunit.DateTickUnit ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ClusteredXYBarChartHotspotTest {

  public IJChart createChart() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createClusteredXYBar2DChart(
      "Vertical", null, "Y", dataset, ChartOrientation.VERTICAL, true, false, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    IntervalXYValueAxis valueAxis = (IntervalXYValueAxis) xyplot.getDomainAxis() ;
    valueAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_DAY)) ;

    XYClusteredBar2DRender render = (XYClusteredBar2DRender) xyplot.getRender() ;
    render.setRowItemFillPaint(0, new GradientPaint(0.0F, 0.0F, Color.red, 0.0F, 0.0F,
                                                    Color.yellow)) ;
    render.setRowItemFillPaint(1, new GradientPaint(0.0F, 0.0F, Color.blue, 0.0F, 0.0F,
                                                    Color.green)) ;
    render.setBaseItemFillPaintTransformer(GradientPaintTransformType.VERTICAL) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData(2) ;

    dataset.addData(0, new IntervalXYNumberChartData(toMills(1, 1, 2003),
                                                     toMills(2, 1, 2003), 0, 54.299999999999997D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(toMills(2, 1, 2003),
                                                     toMills(3, 1, 2003), 0, 20.300000000000001D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(toMills(3, 1, 2003),
                                                     toMills(4, 1, 2003), 0, 43.399999999999999D)) ;
    dataset.addData(0, new IntervalXYNumberChartData(toMills(4, 1, 2003),
                                                     toMills(5, 1, 2003), 0, -12D)) ;

    dataset.addData(1, new IntervalXYNumberChartData(toMills(1, 1, 2003),
                                                     toMills(2, 1, 2003), 0, 8D)) ;
    dataset.addData(1, new IntervalXYNumberChartData(toMills(2, 1, 2003),
                                                     toMills(3, 1, 2003), 0, 16D)) ;
    dataset.addData(1, new IntervalXYNumberChartData(toMills(3, 1, 2003),
                                                     toMills(4, 1, 2003), 0, 21D)) ;
    dataset.addData(1, new IntervalXYNumberChartData(toMills(4, 1, 2003),
                                                     toMills(5, 1, 2003), 0, 5D)) ;

    return dataset ;
  }

  private static long toMills(int day, int month, int year) {
    return DateUtil.dateToTimeInMillis(year, month, day) ;
  }

}
