package demo.images ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MinMaxChartHotspotTest {

  public IJChart createChart() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryMinMaxChart("Min/Max Category Plot", "Category",
                                                           "Value", dataset,
                                                           ChartOrientation.VERTICAL, true, true) ;

    return chart ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("First") ;
    dataset.addRowKey("Second") ;
    dataset.addRowKey("Third") ;

    double[][] datas = { {1.0D, 4D, 3D, 5D, 5D, 7D, 7D, 8D}, {5D, 7D, 6D, 8D, 4D, 4D, 2D, 1.0D},
                       {4D, 3D, 2D, 3D, 6D, 3D, 4D, 3D}
    } ;

    for (int i = 0 ; i < datas.length ; i++) {
      dataset.addRowData() ;
      for (int j = 0 ; j < datas[i].length ; j++) {
        if (i == 0) {
          dataset.addColKey("C" + (j + 1)) ;
        }
        dataset.addData(i, new NumberChartData(datas[i][j])) ;
      }

    }

    return dataset ;
  }

}
