package demo.miscellaneous ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GridBandDemo1 extends JPanel {

  public GridBandDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createScatterChart("Grid Band Demo 1", "X", "Y", dataset,
                                                    ChartOrientation.VERTICAL, true, true,
                                                    false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;

    XYNumberValueAxis xAxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    xAxis.setAxisRangeIncludeZero(false) ;
    xAxis.setGridBandVisible(true) ;
    xAxis.setGridBandPaint(new Color(0, 100, 0, 50)) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) plot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;
    yAxis.setGridBandVisible(true) ;
    yAxis.setGridBandPaint(new Color(0, 100, 0, 50)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  public static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random Data") ;
    dataset.addRowData() ;

    for (int i = 0 ; i < 100 ; i++) {
      dataset.addData(0, new XYNumberChartData(Math.random() + 1.0D, Math.random() + 1.0D)) ;
    }

    return dataset ;
  }

}
