package demo.miscellaneous ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.ErrorValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.LegendType ;
import com.ijchart.xychart.data.ErrorChartData ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYErrorRender ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class YIntervalChartDemo2 extends JPanel {

  public YIntervalChartDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYErrorChart("YIntervalChartDemo2", "Date", "Value",
                                                    dataset, ChartOrientation.VERTICAL,
                                                    true, true, true, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    ErrorValueAxis numberaxis = (ErrorValueAxis) xyplot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    numberaxis.setAxisRangeIncludeZero(false) ;
    XYErrorRender render = (XYErrorRender) xyplot.getRender() ;
    render.setCustomLegendType(LegendType.NONE) ;

    XYLineAndShapeRender render2 = new XYLineAndShapeRender(createDataset2()) ;
    render2.setAutoSelectBorderPaint(false) ;
    render2.setBaseItemBorderPaint(Color.red) ;
    render2.setAutoSelectFillPaint(false) ;
    render2.setBaseItemFillPaint(Color.white) ;
    xyplot.setRender(1, render2) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowData() ;

    dataset.addData(0, createErrorData(2005, 4, 16, 1309D, 13D)) ;
    dataset.addData(0, createErrorData(2005, 9, 18, 1312D, 12D)) ;
    dataset.addData(0, createErrorData(2005, 10, 7, 1309D, 12D)) ;
    dataset.addData(0, createErrorData(2006, 0, 12, 1311D, 12D)) ;
    dataset.addData(0, createErrorData(2006, 1, 7, 1311D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 3, 3, 1309D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 3, 4, 1307D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 3, 6, 1305D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 3, 13, 1303D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 3, 25, 1308D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 3, 28, 1311D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 4, 2, 1306D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 4, 15, 1303D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 4, 18, 1311D, 13D)) ;
    dataset.addData(0, createErrorData(2006, 10, 16, 1301D, 13D)) ;

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowData() ;

    dataset.addData(0, createXYData(2005, 4, 16, 1309D, 13D)) ;
    dataset.addData(0, createXYData(2005, 9, 18, 1312D, 12D)) ;
    dataset.addData(0, createXYData(2005, 10, 7, 1309D, 12D)) ;
    dataset.addData(0, createXYData(2006, 0, 12, 1311D, 12D)) ;
    dataset.addData(0, createXYData(2006, 1, 7, 1311D, 13D)) ;
    dataset.addData(0, createXYData(2006, 3, 3, 1309D, 13D)) ;
    dataset.addData(0, createXYData(2006, 3, 4, 1307D, 13D)) ;
    dataset.addData(0, createXYData(2006, 3, 6, 1305D, 13D)) ;
    dataset.addData(0, createXYData(2006, 3, 13, 1303D, 13D)) ;
    dataset.addData(0, createXYData(2006, 3, 25, 1308D, 13D)) ;
    dataset.addData(0, createXYData(2006, 3, 28, 1311D, 13D)) ;
    dataset.addData(0, createXYData(2006, 4, 2, 1306D, 13D)) ;
    dataset.addData(0, createXYData(2006, 4, 15, 1303D, 13D)) ;
    dataset.addData(0, createXYData(2006, 4, 18, 1311D, 13D)) ;
    dataset.addData(0, createXYData(2006, 10, 16, 1301D, 13D)) ;

    return dataset ;
  }

  private static ErrorChartData createErrorData(int year, int month, int day, double d, double d1) {
    double time = DateUtil.dateToTimeInMillis(year, month, day) ;
    return new ErrorChartData(time, time, time, d, d - d1, d + d1) ;
  }

  private static XYNumberChartData createXYData(int year, int month, int day, double d, double d1) {
    return new XYNumberChartData(DateUtil.dateToTimeInMillis(year, month, day), d) ;
  }

}
