package demo.miscellaneous.itemlabel ;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.Font ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.TextDirection ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.AbstractCategoryRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ItemLabelDemo3 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public ItemLabelDemo3() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart("Item Label Demo 3", "Category",
                                                          "Value", dataset, orientation, false, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setValueGridlinePaint(Color.white) ;
    plot.getCategoryAxis().setVisible(false) ;
    plot.getValueAxis().setUpperMargin(0.04999999999999999D) ;

    AbstractCategoryRender render = plot.getRender() ;
    render.setBaseItemLabelVisible(true) ;
    render.setBaseItemLabelFont(new Font("SansSerif", 0, 12)) ;
    render.setBaseItemLabelDirection(TextDirection.VERTICAL) ;
    render.setLabelGenerator(new DefaultLabelGenerator() {

      public String generateLabel(IMatrixDataset dataset, int row, int column) {
        return dataset.getRowKey(row).toString() ;
      }

    }) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Series 1") ;
    dataset.addRowKey("Apples") ;
    dataset.addRowKey("Bananas") ;
    dataset.addRowKey("Oranges") ;
    dataset.addRowKey("Pears") ;
    dataset.addRowKey("Plums") ;
    dataset.addRowData(5) ;

    dataset.addData(0, new NumberChartData(51D)) ;
    dataset.addData(1, new NumberChartData(44.299999999999997D)) ;
    dataset.addData(2, new NumberChartData(93D)) ;
    dataset.addData(3, new NumberChartData(35.600000000000001D)) ;
    dataset.addData(4, new NumberChartData(75.099999999999994D)) ;

    return dataset ;
  }

}
