package demo.miscellaneous.itemlabel ;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.Font ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.title.TextTitle ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ItemLabelDemo4 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public ItemLabelDemo4() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart("Java Standard Class Library",
                                                                 "Release", "Class Count", dataset,
                                                                 orientation, false, true) ;
    chart.addSubtitle(new TextTitle("Number of Classes By Release")) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setValueGridlinePaint(Color.white) ;
    TextTitle texttitle = new TextTitle(
      "Source: Java In A Nutshell (4th Edition) by David Flanagan (O'Reilly)") ;
    texttitle.setTextFont(new Font("SansSerif", 1, 12)) ;
    texttitle.setPosition(RectangleEdge.BOTTOM) ;
    texttitle.setHorizontalAlignment(HorizontalAlignment.RIGHT) ;
    chart.addSubtitle(texttitle) ;

    LineAndShapeRender render = (LineAndShapeRender) plot.getRender() ;
    render.setBaseItemShapeVisible(true) ;
    render.setBaseItemShapeFilled(true) ;
    render.setAutoSelectFillPaint(false) ;
    render.setBaseItemFillPaint(Color.white) ;
    render.setBaseItemLabelVisible(true) ;

    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setUpperMargin(0.04999999999999999D) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Classes") ;
    dataset.addColKey("JDK 1.0") ;
    dataset.addColKey("JDK 1.1") ;
    dataset.addColKey("SDK 1.2") ;
    dataset.addColKey("SDK 1.3") ;
    dataset.addColKey("SDK 1.4") ;
    dataset.addRowData(1) ;

    dataset.addData(0, new NumberChartData(212D)) ;
    dataset.addData(0, new NumberChartData(504D)) ;
    dataset.addData(0, new NumberChartData(1520D)) ;
    dataset.addData(0, new NumberChartData(1842D)) ;
    dataset.addData(0, new NumberChartData(2991D)) ;

    return dataset ;
  }

}
