package demo.others.annotationcharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.annotation.CategoryTextAnnotation ;
import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class CategoryTextAnnotationTest2 extends JPanel {

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public CategoryTextAnnotationTest2() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
//    addPanel4() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    CategoryTextAnnotation categorytextannotation = new CategoryTextAnnotation(
      "Minimum grade to pass", "Robert", 0.70999999999999996D) ;
    plot.getRender().addAnnotation(categorytextannotation) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    CategoryTextAnnotation categorytextannotation = new CategoryTextAnnotation(
      "Minimum grade to pass", "Robert", 0.70999999999999996D) ;
    plot.getRender().addAnnotation(categorytextannotation) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    CategoryTextAnnotation categorytextannotation = new CategoryTextAnnotation(
      "Minimum grade to pass", "Robert", 0.70999999999999996D) ;
    plot.getRender().addAnnotation(categorytextannotation) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset defaultcategorydataset = new DefaultMatrixDataset() ;
    defaultcategorydataset.addRowKey("Robert") ;
    defaultcategorydataset.addRowKey("Mary") ;
    defaultcategorydataset.addRowKey("John") ;
    defaultcategorydataset.addRowKey("Ellen") ;
    defaultcategorydataset.addRowKey("Jack") ;
    defaultcategorydataset.addRowKey("David") ;
    defaultcategorydataset.addRowKey("Mark") ;
    defaultcategorydataset.addRowKey("Andy") ;

    defaultcategorydataset.addColKey("Series 1") ;

    defaultcategorydataset.addRowData() ;
    defaultcategorydataset.addData(0, new NumberChartData(0.77000000000000002D)) ;

    defaultcategorydataset.addRowData() ;
    defaultcategorydataset.addData(1, new NumberChartData(0.93000000000000005D)) ;

    defaultcategorydataset.addRowData() ;
    defaultcategorydataset.addData(2, new NumberChartData(0.58999999999999997D)) ;

    defaultcategorydataset.addRowData() ;
    defaultcategorydataset.addData(3, new NumberChartData(0.75D)) ;

    defaultcategorydataset.addRowData() ;
    defaultcategorydataset.addData(4, new NumberChartData(0.63D)) ;

    defaultcategorydataset.addRowData() ;
    defaultcategorydataset.addData(5, new NumberChartData(0.94999999999999996D)) ;

    defaultcategorydataset.addRowData() ;
    defaultcategorydataset.addData(6, new NumberChartData(0.70999999999999996D)) ;

    defaultcategorydataset.addRowData() ;
    defaultcategorydataset.addData(7, new NumberChartData(0.65000000000000002D)) ;

    return defaultcategorydataset ;
  }

}
