package demo.others.metercharts ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.MeterShapeType ;
import com.ijchart.xychart.data.StartEndNumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.MeterRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class MeterChartPanel1 extends JPanel {

  public MeterChartPanel1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    SingleRowDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createMeterChart(
      "This is a very long title,it has many words and wrap automatically.", dataset, true, true) ;

    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    MeterRender render = (MeterRender) plot.getRender() ;
    render.setBackgroundPaint(Color.YELLOW) ;
    render.setMeterAngle(60) ;
    render.setTickSize(5) ;
    render.setValue(12) ;
    render.setMeterShapeType(MeterShapeType.PIE) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset volumeDataset = new SingleRowDataset() ;
    volumeDataset.addRowKey("Volume") ;
    volumeDataset.addRowData() ;

    volumeDataset.addColKey("Normal") ;
    volumeDataset.addColKey("Warning") ;
    volumeDataset.addColKey("Critical") ;

    volumeDataset.addData(0, new StartEndNumberChartData(0.0D, 35D)) ;
    volumeDataset.addData(0, new StartEndNumberChartData(35D, 50D)) ;
    volumeDataset.addData(0, new StartEndNumberChartData(50D, 60D)) ;

    return volumeDataset ;
  }
}
