package demo.others.shapes;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.geom.Arc2D ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.JPanel ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ArcShapeTestPanel extends JPanel {
  private Map hashMap = new HashMap() ;

  public ArcShapeTestPanel() {
    setLayout(new GridLayout(4, 2)) ;

    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
    addPanel5() ;
    addPanel6() ;
    addPanel7() ;
    addPanel8() ;
  }

  private void addPanel1() {
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        final int width = 100 ;
        final int height = 100 ;

        Rectangle2D chartArea = new Rectangle2D.Double(50, 50, width, height) ;
        g2.draw(chartArea) ;

        Arc2D arc = new Arc2D.Double(50, 50, width, height, 0, 45, Arc2D.CHORD) ;
        g2.draw(arc) ;

      }
    } ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    add(panel) ;
  }

  private void addPanel2() {
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        final int width = 100 ;
        final int height = 100 ;

        Rectangle2D chartArea = new Rectangle2D.Double(50, 50, width, height) ;
        g2.draw(chartArea) ;

        Arc2D arc = new Arc2D.Double(50, 50, width, height, 0, 90, Arc2D.CHORD) ;
        g2.draw(arc) ;

      }
    } ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    add(panel) ;
  }

  private void addPanel3() {
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        final int width = 100 ;
        final int height = 100 ;

        Rectangle2D chartArea = new Rectangle2D.Double(50, 50, width, height) ;
        g2.draw(chartArea) ;

        Arc2D arc = new Arc2D.Double(50, 50, width, height, 0, 180, Arc2D.CHORD) ;
        g2.draw(arc) ;

      }
    } ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    add(panel) ;
  }

  private void addPanel4() {
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        final int width = 100 ;
        final int height = 100 ;

        Rectangle2D chartArea = new Rectangle2D.Double(50, 50, width, height) ;
        g2.draw(chartArea) ;

        Arc2D arc = new Arc2D.Double(50, 50, width, height, 0, 90, Arc2D.OPEN) ;
        g2.draw(arc) ;

      }
    } ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    add(panel) ;
  }

  private void addPanel5() {
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        final int width = 100 ;
        final int height = 100 ;

        Rectangle2D chartArea = new Rectangle2D.Double(50, 50, width, height) ;
        g2.draw(chartArea) ;

        Arc2D arc = new Arc2D.Double(50, 50, width, height, 0, 90, Arc2D.PIE) ;
        g2.draw(arc) ;

      }
    } ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    add(panel) ;
  }

  private void addPanel6() {
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        final int width = 100 ;
        final int height = 100 ;

        Rectangle2D chartArea = new Rectangle2D.Double(50, 50, width, height) ;
        g2.draw(chartArea) ;

        Arc2D arc = new Arc2D.Double(50, 50, width, height, -45, 270, Arc2D.PIE) ;
        g2.draw(arc) ;

      }
    } ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    add(panel) ;
  }

  private void addPanel7() {
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        final int width = 100 ;
        final int height = 100 ;

        Rectangle2D chartArea = new Rectangle2D.Double(50, 50, width, height) ;
        g2.draw(chartArea) ;

        Arc2D arc = new Arc2D.Double(50, 50, width, height, -45, 270, Arc2D.CHORD) ;
        g2.draw(arc) ;

      }
    } ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    add(panel) ;
  }

  private void addPanel8() {
    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        super.paintComponent(g) ;
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        g2.setPaint(Color.red) ;

        final int width = 100 ;
        final int height = 50 ;

        Rectangle2D chartArea = new Rectangle2D.Double(0, 0, width, height) ;
        g2.draw(chartArea) ;

        Arc2D arc = new Arc2D.Double(0, 0, width, height, 0, 360, Arc2D.OPEN) ;
        g2.draw(arc) ;

      }
    } ;

    panel.setPreferredSize(new Dimension(200, 200)) ;
    add(panel) ;
  }
}
