package demo.others.shapes ;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.constant.TransformShapeType ;
import com.ijchart.xychart.shape.EllipseTextChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class EllipseTextChartShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public EllipseTextChartShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(3, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
    addPanel5() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    final EllipseTextChartShape textShape = new EllipseTextChartShape(
      new Rectangle2D.Double(30, 30, 50, 50), "text") ;
    textShape.setSelected(true) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
        textShape.setDrawBorder(true) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel2() {
    final EllipseTextChartShape textShape = new EllipseTextChartShape(
      new Rectangle2D.Double(30, 30, 50, 50), "text") ;
    textShape.setFillPaint(Color.blue) ;
    textShape.setFillShape(true) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
        textShape.setDrawBorder(true) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel3() {
    final EllipseTextChartShape textShape = new EllipseTextChartShape(
      new Rectangle2D.Double(30, 30, 50, 50), "text") ;
    textShape.setFillPaint(Color.blue) ;
    textShape.setFillShape(true) ;
    textShape.setBorderPaint(Color.yellow) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
        textShape.setDrawBorder(true) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel4() {
    final EllipseTextChartShape textShape = new EllipseTextChartShape(
      new Rectangle2D.Double(30, 30, 50, 50), "text") ;
    textShape.setBorderPaint(Color.yellow) ;
    textShape.setTextPosition(TextPosition.OUTSIDE_TOP) ;
    textShape.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.draw((Graphics2D) g) ;
        textShape.setDrawBorder(true) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

  private void addPanel5() {
    final EllipseTextChartShape textShape = new EllipseTextChartShape(
      new Rectangle2D.Double(30, 30, 50, 50), null) ;
    textShape.setBorderPaint(Color.red) ;
    textShape.setTransformShapeType(TransformShapeType.OUTLINE) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setDrawBorder(true) ;
        textShape.draw((Graphics2D) g) ;
      }

    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;
    add(panel) ;
  }

}
