package demo.others.shapes ;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Font ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.TextDirection ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.shape.RectangleTextChartShape ;
import com.ijchart.xychart.test.SerialTestUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class RectangleTextChartShapePanel2 extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public RectangleTextChartShapePanel2() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(5, 4)) ;
    addPanel20() ;
    addPanel21() ;
    addPanel22() ;
    addPanel23() ;

    addPanel24() ;
    addPanel25() ;
    addPanel26() ;
    addPanel27() ;
    addPanel28() ;
    addPanel29() ;

    addPanel30() ;
    addPanel31() ;
    addPanel32() ;
    addPanel33() ;
    addPanel34() ;
    addPanel35() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel20() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(10, 10, 100, 50), "Right\n1234567890",
      new Font("SansSerif", Font.ITALIC, 15)) ;
    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_BOTTOM) ;
    text.setTextHorizontalAlign(HorizontalAlignment.RIGHT) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel21() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(50, 10, 40, 50),
                                  "Top\n12345\n67890abcdef\nopqrstuvwxyz",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_BOTTOM) ;
    text.setTextVerticalAlign(VerticalAlignment.TOP) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel22() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(50, 10, 30, 50),
                                  "Center\n12345\n67890abcdef\nopqrstuvwxyz",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_BOTTOM) ;
    text.setTextVerticalAlign(VerticalAlignment.CENTER) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel23() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(50, 10, 30, 50),
                                  "Bottom\n12345\n67890abcdef\nopqrstuvwxyz",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_BOTTOM) ;
    text.setTextVerticalAlign(VerticalAlignment.BOTTOM) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel24() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(10, 10, 100, 50), "Left\n1234567890\nabcdef\nghijklmn",
      new Font("SansSerif", Font.ITALIC, 15)) ;
//    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_RIGHT) ;
    text.setTextVerticalAlign(VerticalAlignment.TOP) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel25() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(10, 10, 100, 50), "Center\n1234567890\nabcdef\nghijklmn",
      new Font("SansSerif", Font.ITALIC, 15)) ;
    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_RIGHT) ;
    text.setTextVerticalAlign(VerticalAlignment.CENTER) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel26() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(10, 10, 100, 50), "Right\n1234567890\nabcdef\nghijklmn",
      new Font("SansSerif", Font.ITALIC, 15)) ;
    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_RIGHT) ;
    text.setTextVerticalAlign(VerticalAlignment.BOTTOM) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel27() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(50, 10, 40, 50),
                                  "TopFGfgJj\n12345\n67890abcdef\nopqrstuvwxyz",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_RIGHT) ;
    text.setTextVerticalAlign(VerticalAlignment.TOP) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel28() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(50, 30, 30, 50),
                                  "CenterFG\na\nCenterFGfgJj\n12345\n67890abcdef\nopqrstuvwxyz",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_RIGHT) ;
    text.setTextVerticalAlign(VerticalAlignment.CENTER) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel29() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(50, 10, 30, 50),
                                  "BottomFGfgJj\n12345\n67890abcdef\nopqrstuvwxyz",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_RIGHT) ;
    text.setTextVerticalAlign(VerticalAlignment.BOTTOM) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel30() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(50, 10, 100, 50), "Left\n1234567890\nabcdef\nghijklmn",
      new Font("SansSerif", Font.ITALIC, 15)) ;
//    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_LEFT) ;
    text.setTextVerticalAlign(VerticalAlignment.TOP) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel31() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(50, 10, 100, 50), "Center\n1234567890\nabcdef\nghijklmn",
      new Font("SansSerif", Font.ITALIC, 15)) ;
//    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_LEFT) ;
    text.setTextVerticalAlign(VerticalAlignment.CENTER) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel32() {
    RectangleTextChartShape text = new RectangleTextChartShape(
      new Rectangle2D.Double(50, 10, 100, 50), "Right\n1234567890\nabcdef\nghijklmn",
      new Font("SansSerif", Font.ITALIC, 15)) ;
//    text.setRotate(Math.PI / 30) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_LEFT) ;
    text.setTextVerticalAlign(VerticalAlignment.BOTTOM) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel33() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(70, 10, 20, 50),
                                  "TopFGfgJj\n12345\n67890abcdef\nopqrs",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_LEFT) ;
    text.setTextVerticalAlign(VerticalAlignment.TOP) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel34() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(70, 30, 20, 50),
                                  "CenterFG\na\nCenterFGfgJj\n12345\n67890abcdef\nopqrstuvwxyz",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_LEFT) ;
    text.setTextVerticalAlign(VerticalAlignment.CENTER) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

  private void addPanel35() {
    RectangleTextChartShape text =
      new RectangleTextChartShape(new Rectangle2D.Double(70, 10, 20, 50),
                                  "BottomFGfgJj\n12345\n67890abcdef\nopqrstuvwxyz",
                                  new Font("SansSerif", Font.ITALIC, 15)) ;
//     text.setRotate(Math.PI / 5) ;
    text.setFillShape(true) ;
    text.setFillPaint(Color.yellow) ;
    text.setTextPaint(Color.red) ;
    text.setTextPosition(TextPosition.OUTSIDE_LEFT) ;
    text.setTextVerticalAlign(VerticalAlignment.BOTTOM) ;
    text.setTextDirection(TextDirection.VERTICAL) ;
    text.setDrawBorder(true) ;

    SerialTestUtil.serialObject(text) ;
    final RectangleTextChartShape textShape = (RectangleTextChartShape) SerialTestUtil.
                                              unserialObject() ;

    JPanel panel = new JPanel() {

      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;
        setBackground(Color.white) ;
        super.paintComponent(g) ;

        textShape.setSelected(true) ;
        textShape.draw(g2) ;
      }

    } ;
    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + textShape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(110, 110)) ;

    add(panel) ;
  }

}
