package demo.others.stackareacharts ;

import java.awt.Color ;
import java.awt.GradientPaint ;
import java.awt.GridLayout ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.GradientPaintTransformType ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.AppendFormatter ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYStackedBarRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StackedXYBarChartPanel7 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public StackedXYBarChartPanel7() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//    addPanel2() ;
//    addPanel3() ;
//    addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedXYBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYStackedBarRender render = (XYStackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;
    render.setMargin(0.14999999999999999D) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_TOP) ;
    setChartLabelXY(chart) ;
    changeRender(plot, render) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStackedXYBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYStackedBarRender render = (XYStackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;
    render.setMargin(0.29999999999999999D) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_BOTTOM) ;
    setChartLabelXY(chart) ;
    changeRender(plot, render) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new com.ijchart.xychart.client.ChartPanel(
      chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IJChart chart = ChartFactory.createStackedXYBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset1(), horizontal, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYStackedBarRender render = (XYStackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;
    render.setMargin(0.29999999999999999D) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_RIGHT) ;
    setChartLabelXY(chart) ;
    changeRender(plot, render) ;
//        ((XYStackedBarRender) plot.getRender()).setAutoWidth(false) ;

    ChartPanel chartpanel = new com.ijchart.xychart.client.ChartPanel(
      chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IJChart chart = ChartFactory.createStackedXYBarChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", createDataset1(), horizontal, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYStackedBarRender render = (XYStackedBarRender) plot.getRender() ;
    render.setRenderAsPercentages(true) ;
    render.setMargin(0.29999999999999999D) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_LEFT) ;
    setChartLabelXY(chart) ;
    changeRender(plot, render) ;
//        ((XYStackedBarRender) plot.getRender()).setAutoWidth(true) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;

    ChartPanel chartpanel = new com.ijchart.xychart.client.ChartPanel(
      chart) ;
    add(chartpanel) ;
  }

  private static void setChartLabelXY(IJChart chart) {
//    XYPlot plot = (XYPlot) chart.getPlot() ;
//    plot.setForegroundAlpha(0.8F) ;
//    AbstractXYRender render = plot.getRender() ;
//    XYNumberChartDataFormatter format =
//      new XYNumberChartDataFormatter("#.#", "#.#",
//                                     XYNumberChartDataFormatter.XYNUMBER_FORMATTER_TYPE_Y) ;
//    ILabelGenerator labelGenerator = new DefaultLabelGenerator(format) ;
//
//    render.setItemLabelGenerator(labelGenerator) ;
//    render.setGeneratorLabel(true) ;

  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    for (int i = 0 ; i < 5 ; i++) {
      dataset.addColKey("Col" + (i + 1)) ;
    }

    dataset.addRowKey("Landfilled") ;
    dataset.addRowKey("Recycled") ;

    dataset.addRowData() ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2002), 41287D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2003), 41096D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2004), 39603D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2005), 39693D)) ;
    dataset.addData(0, new XYNumberChartData(getYearMills(2006), 37227D)) ;

    dataset.addRowData() ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2002), 7717D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2003), 8317D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2004), 9493D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2005), 11228D)) ;
    dataset.addData(1, new XYNumberChartData(getYearMills(2006), 14941D)) ;

    return dataset ;
  }

  private static long getYearMills(int year) {
    Date date = new Date(year - 1900, 1, 1, 0, 0, 0) ;
    return date.getTime() ;
  }

  private void changeRender(XYPlot plot, XYStackedBarRender render) {
    GradientPaint gradientpaint = new GradientPaint(0.0F, 0.0F, new Color(64, 0, 0), 0.0F, 0.0F,
                                                    Color.red) ;
    GradientPaint gradientpaint1 = new GradientPaint(0.0F, 0.0F, new Color(0, 64, 0), 0.0F,
                                                     0.0F, Color.green) ;
    render.setAutoSelectFillPaint(false) ;
    render.setRowItemFillPaint(0, gradientpaint) ;
    render.setRowItemFillPaint(1, gradientpaint1) ;
    render.setRowItemFillPaintTransformer(0, GradientPaintTransformType.HORIZONTAL) ;
    render.setRowItemFillPaintTransformer(1, GradientPaintTransformType.HORIZONTAL) ;

    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setTickValueFormatter(new AppendFormatter(null, "%")) ;

  }

}
