package demo.others.xy ;

import java.awt.GridLayout ;
import java.util.Calendar ;
import java.util.Date ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYClusteredBar2DRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ClusteredXYNumberBar2DChartPanel1 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public ClusteredXYNumberBar2DChartPanel1() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//    addPanel2() ;
//    addPanel3() ;
//    addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createClusteredXYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYClusteredBar2DRender xyRender = (XYClusteredBar2DRender) plot.getRender() ;
    xyRender.setCenterBarAtStartValue(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createClusteredXYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYClusteredBar2DRender xyRender = (XYClusteredBar2DRender) plot.getRender() ;
    xyRender.setCenterBarAtStartValue(false) ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createClusteredXYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, true, false) ;

//        setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYClusteredBar2DRender xyRender = (XYClusteredBar2DRender) plot.getRender() ;
    xyRender.setCenterBarAtStartValue(false) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.5F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.5F)) ;
//
//        AbstractValueAxis valueAxis = plot.getValueAxis() ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createClusteredXYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, true, false) ;

//        setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYClusteredBar2DRender xyRender = (XYClusteredBar2DRender) plot.getRender() ;
    xyRender.setCenterBarAtStartValue(false) ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(4.0F)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Col1") ;
    dataset.addColKey("Col2") ;
    dataset.addColKey("Col3") ;
    dataset.addColKey("Col4") ;

    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;
    dataset.addRowKey("Row3") ;

    Calendar currDay = null ;
    Calendar nextDay = null ;

    dataset.addRowData() ;
    currDay = createCalendar(2003, 1, 1) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(0, createData(currDay, nextDay, 54.299999999999997D)) ;

    currDay = createCalendar(2003, 1, 2) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(0, createData(currDay, nextDay, 20.300000000000001D)) ;

    currDay = createCalendar(2003, 1, 3) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(0, createData(currDay, nextDay, 43.399999999999999D)) ;

    currDay = createCalendar(2003, 1, 4) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(0, createData(currDay, nextDay, -12D)) ;

    dataset.addRowData() ;

    currDay = createCalendar(2003, 1, 1) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(1, createData(currDay, nextDay, 8D)) ;

    currDay = createCalendar(2003, 1, 2) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(1, createData(currDay, nextDay, 16D)) ;

    currDay = createCalendar(2003, 1, 3) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(1, createData(currDay, nextDay, 21D)) ;

    currDay = createCalendar(2003, 1, 4) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(1, createData(currDay, nextDay, 5D)) ;

    dataset.addRowData() ;

    currDay = createCalendar(2003, 1, 1) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(2, createData(currDay, nextDay, 8D)) ;

    currDay = createCalendar(2003, 1, 2) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(2, createData(currDay, nextDay, 16D)) ;

    currDay = createCalendar(2003, 1, 3) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(2, createData(currDay, nextDay, 21D)) ;

    currDay = createCalendar(2003, 1, 4) ;
    nextDay = getNextDay(currDay) ;
    dataset.addData(2, createData(currDay, nextDay, 5D)) ;

    return dataset ;
  }

  private static IntervalXYNumberChartData createData(Calendar calStart, Calendar calEnd,
                                                      double value) {
    long start = calStart.getTime().getTime() ;
    long end = calEnd.getTime().getTime() ;

    return new IntervalXYNumberChartData(start, end, 0, value) ;
  }

  private static Calendar createCalendar(int year, int month, int day) {
    Calendar cal = Calendar.getInstance() ;
    cal.set(year, month - 1, day, 0, 0, 0) ;
    cal.set(Calendar.MILLISECOND, 0) ;

    return cal ;
  }

  private static Calendar getNextDay(Calendar cal) {
    Calendar result = Calendar.getInstance() ;
    result.setTime(new Date(cal.getTime().getTime() + 24 * 60 * 60 * 1000)) ;

    return result ;
  }

}
