package demo.others.xy ;

import java.awt.GridLayout ;
import java.io.BufferedReader ;
import java.io.FileInputStream ;
import java.io.FileNotFoundException ;
import java.io.IOException ;
import java.io.InputStreamReader ;

import javax.swing.JPanel ;

import com.ijchart.xychart.annotation.XYTextAnnotation ;
import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.AbstractXYRender ;
import demo.DemosTree ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class GrowthVerticalChart extends JPanel {
  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private String dataFilePath = DemosTree.class.getResource("others/resource/wtageinf.txt").getPath() ;

  public GrowthVerticalChart() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setUpperMargin(0.05) ;
    AbstractValueAxis domainAxis = plot.getDomainAxis() ;
    domainAxis.setUpperMargin(0.03) ;
    AbstractXYRender render = plot.getRender() ;

    XYTextAnnotation xytextannotation = null ;
//        Font font = new Font("SansSerif", 0, 9) ;
    xytextannotation = new XYTextAnnotation("3rd", 36.5D, 11.76D) ;
    render.addAnnotation(xytextannotation) ;

    xytextannotation = new XYTextAnnotation("5th", 36.5D, 12.039999999999999D) ;
    render.addAnnotation(xytextannotation) ;

    xytextannotation = new XYTextAnnotation("10th", 36.5D, 12.493D) ;
    render.addAnnotation(xytextannotation) ;

    xytextannotation = new XYTextAnnotation("25th", 36.5D, 13.313000000000001D) ;
    render.addAnnotation(xytextannotation) ;

    xytextannotation = new XYTextAnnotation("50th", 36.5D, 14.33D) ;
    render.addAnnotation(xytextannotation) ;

    xytextannotation = new XYTextAnnotation("75th", 36.5D, 15.478D) ;
    render.addAnnotation(xytextannotation) ;

    xytextannotation = new XYTextAnnotation("90th", 36.5D, 16.641999999999999D) ;
    render.addAnnotation(xytextannotation) ;

    xytextannotation = new XYTextAnnotation("95th", 36.5D, 17.408000000000001D) ;
    render.addAnnotation(xytextannotation) ;

    xytextannotation = new XYTextAnnotation("97th", 36.5D, 17.936D) ;
    render.addAnnotation(xytextannotation) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    try {
      BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(new FileInputStream(
        dataFilePath))) ;
      String s = bufferedreader.readLine() ;
      s = bufferedreader.readLine() ;
      s = bufferedreader.readLine() ;
      s = bufferedreader.readLine() ;

      dataset.addRowKey("P3") ;
      dataset.addRowKey("P5") ;
      dataset.addRowKey("P10") ;
      dataset.addRowKey("P25") ;
      dataset.addRowKey("P50") ;
      dataset.addRowKey("P75") ;
      dataset.addRowKey("P90") ;
      dataset.addRowKey("P95") ;
      dataset.addRowKey("P97") ;

      for (int i = 0 ; i < 9 ; i++) {
        dataset.addRowData() ;
      }

      for (String s1 = bufferedreader.readLine() ; s1 != null ; s1 = bufferedreader.readLine()) {
        int i = Integer.parseInt(s1.substring(1, 8).trim()) ;
        float f = Float.parseFloat(s1.substring(9, 17).trim()) ;
        float f1 = Float.parseFloat(s1.substring(69, 86).trim()) ;
        float f2 = Float.parseFloat(s1.substring(87, 103).trim()) ;
        float f3 = Float.parseFloat(s1.substring(104, 122).trim()) ;
        float f4 = Float.parseFloat(s1.substring(123, 140).trim()) ;
        float f5 = Float.parseFloat(s1.substring(141, 158).trim()) ;
        float f6 = Float.parseFloat(s1.substring(159, 176).trim()) ;
        float f7 = Float.parseFloat(s1.substring(177, 193).trim()) ;
        float f8 = Float.parseFloat(s1.substring(194, 212).trim()) ;
        float f9 = Float.parseFloat(s1.substring(212, s1.length()).trim()) ;
        if (i == 1) {
          dataset.addData(0, new XYNumberChartData(f, f1)) ;
          dataset.addData(1, new XYNumberChartData(f, f2)) ;
          dataset.addData(2, new XYNumberChartData(f, f3)) ;
          dataset.addData(3, new XYNumberChartData(f, f4)) ;
          dataset.addData(4, new XYNumberChartData(f, f5)) ;
          dataset.addData(5, new XYNumberChartData(f, f6)) ;
          dataset.addData(6, new XYNumberChartData(f, f7)) ;
          dataset.addData(7, new XYNumberChartData(f, f8)) ;
          dataset.addData(8, new XYNumberChartData(f, f9)) ;
        }
      }
    } catch (FileNotFoundException filenotfoundexception) {
      System.err.println(filenotfoundexception) ;
    } catch (IOException ioexception) {
      System.err.println(ioexception) ;
    }

    return dataset ;
  }

}
