package demo.piecharts ;

import java.awt.Font ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.SingleRowDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.PieRender ;
import com.ijchart.xychart.title.TextTitle ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PieChartDemo5 extends JPanel {

  public PieChartDemo5() {
    setLayout(new GridLayout(2, 2)) ;
    addPanel() ;
  }

  private void addPanel() {
    SingleRowDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createPieChart("Chart 1", dataset, false, false) ;
    chart.addSubtitle(new TextTitle("setCircular(true);", new Font("Dialog", 0, 12))) ;

    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    PieRender render = (PieRender) plot.getRender() ;
    render.setCircular(true) ;
    render.setInteriorGap(0.040000000000000001D) ;
    render.setMaximumLabelWidth(0.20000000000000001D) ;

    IJChart chart1 = ChartFactory.createPieChart("Chart 2", dataset, false, false) ;
    chart1.addSubtitle(new TextTitle("setCircular(false);", new Font("Dialog", 0, 12))) ;
    NoAxisPlot plot1 = (NoAxisPlot) chart1.getPlot() ;
    PieRender render1 = (PieRender) plot1.getRender() ;
    render1.setCircular(false) ;
    render1.setInteriorGap(0.040000000000000001D) ;
    render1.setMaximumLabelWidth(0.20000000000000001D) ;

    IJChart chart2 = ChartFactory.createPie3DChart("Chart 3", dataset, false, false) ;
    chart2.addSubtitle(new TextTitle("setCircular(true);", new Font("Dialog", 0, 12))) ;
    NoAxisPlot plot2 = (NoAxisPlot) chart2.getPlot() ;
    PieRender render2 = (PieRender) plot2.getRender() ;
    plot2.setForegroundAlpha(0.6F) ;
    render2.setCircular(true) ;
    render2.setInteriorGap(0.040000000000000001D) ;
    render2.setMaximumLabelWidth(0.20000000000000001D) ;

    IJChart chart3 = ChartFactory.createPie3DChart("Chart 4", dataset, false, false) ;
    chart3.addSubtitle(new TextTitle("setCircular(false);", new Font("Dialog", 0, 12))) ;
    NoAxisPlot plot3 = (NoAxisPlot) chart3.getPlot() ;
    PieRender render3 = (PieRender) plot3.getRender() ;
    plot3.setForegroundAlpha(0.6F) ;
    render3.setCircular(false) ;
    render3.setInteriorGap(0.040000000000000001D) ;
    render3.setMaximumLabelWidth(0.20000000000000001D) ;

    add(new ChartPanel(chart)) ;
    add(new ChartPanel(chart1)) ;
    add(new ChartPanel(chart2)) ;
    add(new ChartPanel(chart3)) ;
  }

  private static SingleRowDataset createDataset() {
    SingleRowDataset dataset = new SingleRowDataset() ;

    dataset.addColKey("Section 1") ;
    dataset.addColKey("Section 2") ;
    dataset.addColKey("Section 3") ;
    dataset.addColKey("Section 4") ;

    dataset.addRowData() ;
    dataset.addData(0, new NumberChartData(23.300000000000001D)) ;
    dataset.addData(0, new NumberChartData(56.5D)) ;
    dataset.addData(0, new NumberChartData(43.299999999999997D)) ;
    dataset.addData(0, new NumberChartData(11.1D)) ;

    return dataset ;
  }

}
