package demo.timeseriescharts ;

import java.awt.GridLayout ;
import java.util.ArrayList ;
import java.util.List ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.DateTickUnitType ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.DateTickUnit ;
import com.ijchart.xychart.util.DatasetUtil ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TimeSeriesDemo8 extends JPanel {

  public TimeSeriesDemo8() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Time Series Demo 8", "Date",
                                                           "Value", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickUnit(new DateTickUnit(DateTickUnitType.DATE_UNIT_MONTH)) ;
    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;

    XYNumberValueAxis yAxis2 = new XYNumberValueAxis(dataset, XYValueAxisType.XY_VALUE_AXIS_Y) ;
    yAxis2.setAxisRangeIncludeZero(false) ;
    xyplot.setValueAxis(1, yAxis2) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("EUR/GBP") ;
    dataset.addRowData() ;

    dataset.addData(0, createData(2, 1, 2001, 1.5788D)) ;
    dataset.addData(0, createData(3, 1, 2001, 1.5912999999999999D)) ;
    dataset.addData(0, createData(4, 1, 2001, 1.5807D)) ;
    dataset.addData(0, createData(5, 1, 2001, 1.5710999999999999D)) ;
    dataset.addData(0, createData(8, 1, 2001, 1.5778000000000001D)) ;
    dataset.addData(0, createData(9, 1, 2001, 1.5851D)) ;
    dataset.addData(0, createData(10, 1, 2001, 1.5846D)) ;
    dataset.addData(0, createData(11, 1, 2001, 1.5727D)) ;
    dataset.addData(0, createData(12, 1, 2001, 1.5585D)) ;
    dataset.addData(0, createData(15, 1, 2001, 1.5693999999999999D)) ;
    dataset.addData(0, createData(16, 1, 2001, 1.5629D)) ;
    dataset.addData(0, createData(17, 1, 2001, 1.5831D)) ;
    dataset.addData(0, createData(18, 1, 2001, 1.5624D)) ;
    dataset.addData(0, createData(19, 1, 2001, 1.5693999999999999D)) ;
    dataset.addData(0, createData(22, 1, 2001, 1.5615000000000001D)) ;
    dataset.addData(0, createData(23, 1, 2001, 1.5656000000000001D)) ;
    dataset.addData(0, createData(24, 1, 2001, 1.5794999999999999D)) ;
    dataset.addData(0, createData(25, 1, 2001, 1.5851999999999999D)) ;
    dataset.addData(0, createData(26, 1, 2001, 1.5797000000000001D)) ;
    dataset.addData(0, createData(29, 1, 2001, 1.5862000000000001D)) ;
    dataset.addData(0, createData(30, 1, 2001, 1.5803D)) ;
    dataset.addData(0, createData(31, 1, 2001, 1.5713999999999999D)) ;
    dataset.addData(0, createData(1, 2, 2001, 1.5717000000000001D)) ;
    dataset.addData(0, createData(2, 2, 2001, 1.5734999999999999D)) ;
    dataset.addData(0, createData(5, 2, 2001, 1.5690999999999999D)) ;
    dataset.addData(0, createData(6, 2, 2001, 1.5676000000000001D)) ;
    dataset.addData(0, createData(7, 2, 2001, 1.5677000000000001D)) ;
    dataset.addData(0, createData(8, 2, 2001, 1.5737000000000001D)) ;
    dataset.addData(0, createData(9, 2, 2001, 1.5653999999999999D)) ;
    dataset.addData(0, createData(12, 2, 2001, 1.5621D)) ;
    dataset.addData(0, createData(13, 2, 2001, 1.5761000000000001D)) ;
    dataset.addData(0, createData(14, 2, 2001, 1.5898000000000001D)) ;
    dataset.addData(0, createData(15, 2, 2001, 1.6045D)) ;
    dataset.addData(0, createData(16, 2, 2001, 1.5851999999999999D)) ;
    dataset.addData(0, createData(19, 2, 2001, 1.5704D)) ;
    dataset.addData(0, createData(20, 2, 2001, 1.5891999999999999D)) ;
    dataset.addData(0, createData(21, 2, 2001, 1.5844D)) ;
    dataset.addData(0, createData(22, 2, 2001, 1.5933999999999999D)) ;
    dataset.addData(0, createData(23, 2, 2001, 1.5951D)) ;
    dataset.addData(0, createData(26, 2, 2001, 1.5848D)) ;
    dataset.addData(0, createData(27, 2, 2001, 1.5706D)) ;
    dataset.addData(0, createData(28, 2, 2001, 1.5680000000000001D)) ;
    dataset.addData(0, createData(1, 3, 2001, 1.5645D)) ;
    dataset.addData(0, createData(2, 3, 2001, 1.5753999999999999D)) ;
    dataset.addData(0, createData(5, 3, 2001, 1.5808D)) ;
    dataset.addData(0, createData(6, 3, 2001, 1.5766D)) ;
    dataset.addData(0, createData(7, 3, 2001, 1.5755999999999999D)) ;
    dataset.addData(0, createData(8, 3, 2001, 1.5760000000000001D)) ;
    dataset.addData(0, createData(9, 3, 2001, 1.5748D)) ;
    dataset.addData(0, createData(12, 3, 2001, 1.5779000000000001D)) ;
    dataset.addData(0, createData(13, 3, 2001, 1.5837000000000001D)) ;
    dataset.addData(0, createData(14, 3, 2001, 1.5886D)) ;
    dataset.addData(0, createData(15, 3, 2001, 1.5931D)) ;
    dataset.addData(0, createData(16, 3, 2001, 1.5945D)) ;
    dataset.addData(0, createData(19, 3, 2001, 1.5880000000000001D)) ;
    dataset.addData(0, createData(20, 3, 2001, 1.5817000000000001D)) ;
    dataset.addData(0, createData(21, 3, 2001, 1.5927D)) ;
    dataset.addData(0, createData(22, 3, 2001, 1.6065D)) ;
    dataset.addData(0, createData(23, 3, 2001, 1.6006D)) ;
    dataset.addData(0, createData(26, 3, 2001, 1.6007D)) ;
    dataset.addData(0, createData(27, 3, 2001, 1.5989D)) ;
    dataset.addData(0, createData(28, 3, 2001, 1.6134999999999999D)) ;
    dataset.addData(0, createData(29, 3, 2001, 1.6282000000000001D)) ;
    dataset.addData(0, createData(30, 3, 2001, 1.609D)) ;
    dataset.addData(0, createData(2, 4, 2001, 1.6107D)) ;
    dataset.addData(0, createData(3, 4, 2001, 1.6093D)) ;
    dataset.addData(0, createData(4, 4, 2001, 1.5880000000000001D)) ;
    dataset.addData(0, createData(5, 4, 2001, 1.5931D)) ;
    dataset.addData(0, createData(6, 4, 2001, 1.5968D)) ;
    dataset.addData(0, createData(9, 4, 2001, 1.6072D)) ;
    dataset.addData(0, createData(10, 4, 2001, 1.6167D)) ;
    dataset.addData(0, createData(11, 4, 2001, 1.6214D)) ;
    dataset.addData(0, createData(12, 4, 2001, 1.6120000000000001D)) ;
    dataset.addData(0, createData(17, 4, 2001, 1.6229D)) ;
    dataset.addData(0, createData(18, 4, 2001, 1.6297999999999999D)) ;
    dataset.addData(0, createData(19, 4, 2001, 1.6158999999999999D)) ;
    dataset.addData(0, createData(20, 4, 2001, 1.5995999999999999D)) ;
    dataset.addData(0, createData(23, 4, 2001, 1.6042000000000001D)) ;
    dataset.addData(0, createData(24, 4, 2001, 1.6061000000000001D)) ;
    dataset.addData(0, createData(25, 4, 2001, 1.6045D)) ;
    dataset.addData(0, createData(26, 4, 2001, 1.597D)) ;
    dataset.addData(0, createData(27, 4, 2001, 1.6094999999999999D)) ;
    dataset.addData(0, createData(30, 4, 2001, 1.6141000000000001D)) ;
    dataset.addData(0, createData(1, 5, 2001, 1.6075999999999999D)) ;
    dataset.addData(0, createData(2, 5, 2001, 1.6076999999999999D)) ;
    dataset.addData(0, createData(3, 5, 2001, 1.6034999999999999D)) ;
    dataset.addData(0, createData(4, 5, 2001, 1.6060000000000001D)) ;
    dataset.addData(0, createData(8, 5, 2001, 1.6177999999999999D)) ;
    dataset.addData(0, createData(9, 5, 2001, 1.6083000000000001D)) ;
    dataset.addData(0, createData(10, 5, 2001, 1.6107D)) ;
    dataset.addData(0, createData(11, 5, 2001, 1.6209D)) ;
    dataset.addData(0, createData(14, 5, 2001, 1.6228D)) ;
    dataset.addData(0, createData(15, 5, 2001, 1.6184000000000001D)) ;
    dataset.addData(0, createData(16, 5, 2001, 1.6167D)) ;
    dataset.addData(0, createData(17, 5, 2001, 1.6223000000000001D)) ;
    dataset.addData(0, createData(18, 5, 2001, 1.6305000000000001D)) ;
    dataset.addData(0, createData(21, 5, 2001, 1.6419999999999999D)) ;
    dataset.addData(0, createData(22, 5, 2001, 1.6484000000000001D)) ;
    dataset.addData(0, createData(23, 5, 2001, 1.6547000000000001D)) ;
    dataset.addData(0, createData(24, 5, 2001, 1.6444000000000001D)) ;
    dataset.addData(0, createData(25, 5, 2001, 1.6577D)) ;
    dataset.addData(0, createData(29, 5, 2001, 1.6606000000000001D)) ;
    dataset.addData(0, createData(30, 5, 2001, 1.6604000000000001D)) ;
    dataset.addData(0, createData(31, 5, 2001, 1.6772D)) ;
    dataset.addData(0, createData(1, 6, 2001, 1.6717D)) ;
    dataset.addData(0, createData(4, 6, 2001, 1.6685000000000001D)) ;
    dataset.addData(0, createData(5, 6, 2001, 1.6620999999999999D)) ;
    dataset.addData(0, createData(6, 6, 2001, 1.6459999999999999D)) ;
    dataset.addData(0, createData(7, 6, 2001, 1.6333D)) ;
    dataset.addData(0, createData(8, 6, 2001, 1.6265000000000001D)) ;
    dataset.addData(0, createData(11, 6, 2001, 1.6311D)) ;
    dataset.addData(0, createData(12, 6, 2001, 1.6237999999999999D)) ;
    dataset.addData(0, createData(13, 6, 2001, 1.6299999999999999D)) ;
    dataset.addData(0, createData(14, 6, 2001, 1.6289D)) ;
    dataset.addData(0, createData(15, 6, 2001, 1.6275999999999999D)) ;
    dataset.addData(0, createData(18, 6, 2001, 1.6298999999999999D)) ;
    dataset.addData(0, createData(19, 6, 2001, 1.6353D)) ;
    dataset.addData(0, createData(20, 6, 2001, 1.6377999999999999D)) ;
    dataset.addData(0, createData(21, 6, 2001, 1.6567000000000001D)) ;
    dataset.addData(0, createData(22, 6, 2001, 1.6523000000000001D)) ;
    dataset.addData(0, createData(25, 6, 2001, 1.6417999999999999D)) ;
    dataset.addData(0, createData(26, 6, 2001, 1.6429D)) ;
    dataset.addData(0, createData(27, 6, 2001, 1.6438999999999999D)) ;
    dataset.addData(0, createData(28, 6, 2001, 1.6605000000000001D)) ;
    dataset.addData(0, createData(29, 6, 2001, 1.6598999999999999D)) ;
    dataset.addData(0, createData(2, 7, 2001, 1.6727000000000001D)) ;
    dataset.addData(0, createData(3, 7, 2001, 1.6619999999999999D)) ;
    dataset.addData(0, createData(4, 7, 2001, 1.6628000000000001D)) ;
    dataset.addData(0, createData(5, 7, 2001, 1.673D)) ;
    dataset.addData(0, createData(6, 7, 2001, 1.6649D)) ;
    dataset.addData(0, createData(9, 7, 2001, 1.6603000000000001D)) ;
    dataset.addData(0, createData(10, 7, 2001, 1.6489D)) ;
    dataset.addData(0, createData(11, 7, 2001, 1.6420999999999999D)) ;
    dataset.addData(0, createData(12, 7, 2001, 1.6497999999999999D)) ;
    dataset.addData(0, createData(13, 7, 2001, 1.6447000000000001D)) ;
    dataset.addData(0, createData(16, 7, 2001, 1.6373D)) ;
    dataset.addData(0, createData(17, 7, 2001, 1.6443000000000001D)) ;
    dataset.addData(0, createData(18, 7, 2001, 1.6246D)) ;
    dataset.addData(0, createData(19, 7, 2001, 1.6294999999999999D)) ;
    dataset.addData(0, createData(20, 7, 2001, 1.6362000000000001D)) ;
    dataset.addData(0, createData(23, 7, 2001, 1.6348D)) ;
    dataset.addData(0, createData(24, 7, 2001, 1.6242000000000001D)) ;
    dataset.addData(0, createData(25, 7, 2001, 1.6241000000000001D)) ;
    dataset.addData(0, createData(26, 7, 2001, 1.6281000000000001D)) ;
    dataset.addData(0, createData(27, 7, 2001, 1.6295999999999999D)) ;
    dataset.addData(0, createData(30, 7, 2001, 1.6278999999999999D)) ;
    dataset.addData(0, createData(31, 7, 2001, 1.6299999999999999D)) ;
    dataset.addData(0, createData(1, 8, 2001, 1.629D)) ;
    dataset.addData(0, createData(2, 8, 2001, 1.6236999999999999D)) ;
    dataset.addData(0, createData(3, 8, 2001, 1.6137999999999999D)) ;
    dataset.addData(0, createData(6, 8, 2001, 1.6121000000000001D)) ;
    dataset.addData(0, createData(7, 8, 2001, 1.617D)) ;
    dataset.addData(0, createData(8, 8, 2001, 1.6134999999999999D)) ;
    dataset.addData(0, createData(9, 8, 2001, 1.5995999999999999D)) ;
    dataset.addData(0, createData(10, 8, 2001, 1.5931D)) ;
    dataset.addData(0, createData(13, 8, 2001, 1.5828D)) ;
    dataset.addData(0, createData(14, 8, 2001, 1.5824D)) ;
    dataset.addData(0, createData(15, 8, 2001, 1.5783D)) ;
    dataset.addData(0, createData(16, 8, 2001, 1.581D)) ;
    dataset.addData(0, createData(17, 8, 2001, 1.5761000000000001D)) ;
    dataset.addData(0, createData(20, 8, 2001, 1.5831D)) ;
    dataset.addData(0, createData(21, 8, 2001, 1.587D)) ;
    dataset.addData(0, createData(22, 8, 2001, 1.5808D)) ;
    dataset.addData(0, createData(23, 8, 2001, 1.5845D)) ;
    dataset.addData(0, createData(24, 8, 2001, 1.5844D)) ;
    dataset.addData(0, createData(28, 8, 2001, 1.5924D)) ;
    dataset.addData(0, createData(29, 8, 2001, 1.595D)) ;
    dataset.addData(0, createData(30, 8, 2001, 1.5941000000000001D)) ;
    dataset.addData(0, createData(31, 8, 2001, 1.5968D)) ;
    dataset.addData(0, createData(3, 9, 2001, 1.6020000000000001D)) ;
    dataset.addData(0, createData(4, 9, 2001, 1.6235999999999999D)) ;
    dataset.addData(0, createData(5, 9, 2001, 1.6352D)) ;
    dataset.addData(0, createData(6, 9, 2001, 1.6302000000000001D)) ;
    dataset.addData(0, createData(7, 9, 2001, 1.6180000000000001D)) ;
    dataset.addData(0, createData(10, 9, 2001, 1.6217999999999999D)) ;
    dataset.addData(0, createData(11, 9, 2001, 1.6182000000000001D)) ;
    dataset.addData(0, createData(12, 9, 2001, 1.6156999999999999D)) ;
    dataset.addData(0, createData(13, 9, 2001, 1.6171D)) ;
    dataset.addData(0, createData(14, 9, 2001, 1.5960000000000001D)) ;
    dataset.addData(0, createData(17, 9, 2001, 1.5952D)) ;
    dataset.addData(0, createData(18, 9, 2001, 1.5863D)) ;
    dataset.addData(0, createData(19, 9, 2001, 1.579D)) ;
    dataset.addData(0, createData(20, 9, 2001, 1.5810999999999999D)) ;
    dataset.addData(0, createData(21, 9, 2001, 1.5916999999999999D)) ;
    dataset.addData(0, createData(24, 9, 2001, 1.6005D)) ;
    dataset.addData(0, createData(25, 9, 2001, 1.5914999999999999D)) ;
    dataset.addData(0, createData(26, 9, 2001, 1.6012D)) ;
    dataset.addData(0, createData(27, 9, 2001, 1.6032D)) ;
    dataset.addData(0, createData(28, 9, 2001, 1.6133D)) ;
    dataset.addData(0, createData(1, 10, 2001, 1.6147D)) ;
    dataset.addData(0, createData(2, 10, 2001, 1.6002000000000001D)) ;
    dataset.addData(0, createData(3, 10, 2001, 1.6041000000000001D)) ;
    dataset.addData(0, createData(4, 10, 2001, 1.6172D)) ;
    dataset.addData(0, createData(5, 10, 2001, 1.6121000000000001D)) ;
    dataset.addData(0, createData(8, 10, 2001, 1.6044D)) ;
    dataset.addData(0, createData(9, 10, 2001, 1.5973999999999999D)) ;
    dataset.addData(0, createData(10, 10, 2001, 1.5914999999999999D)) ;
    dataset.addData(0, createData(11, 10, 2001, 1.6022000000000001D)) ;
    dataset.addData(0, createData(12, 10, 2001, 1.6013999999999999D)) ;
    dataset.addData(0, createData(15, 10, 2001, 1.5942000000000001D)) ;
    dataset.addData(0, createData(16, 10, 2001, 1.5925D)) ;
    dataset.addData(0, createData(17, 10, 2001, 1.6007D)) ;
    dataset.addData(0, createData(18, 10, 2001, 1.6000000000000001D)) ;
    dataset.addData(0, createData(19, 10, 2001, 1.603D)) ;
    dataset.addData(0, createData(22, 10, 2001, 1.6013999999999999D)) ;
    dataset.addData(0, createData(23, 10, 2001, 1.5994999999999999D)) ;
    dataset.addData(0, createData(24, 10, 2001, 1.5951D)) ;
    dataset.addData(0, createData(25, 10, 2001, 1.5952999999999999D)) ;
    dataset.addData(0, createData(26, 10, 2001, 1.6056999999999999D)) ;
    dataset.addData(0, createData(29, 10, 2001, 1.6051D)) ;
    dataset.addData(0, createData(30, 10, 2001, 1.6027D)) ;
    dataset.addData(0, createData(31, 10, 2001, 1.6144000000000001D)) ;
    dataset.addData(0, createData(1, 11, 2001, 1.6138999999999999D)) ;
    dataset.addData(0, createData(2, 11, 2001, 1.6189D)) ;
    dataset.addData(0, createData(5, 11, 2001, 1.6248D)) ;
    dataset.addData(0, createData(6, 11, 2001, 1.6267D)) ;
    dataset.addData(0, createData(7, 11, 2001, 1.6281000000000001D)) ;
    dataset.addData(0, createData(8, 11, 2001, 1.631D)) ;
    dataset.addData(0, createData(9, 11, 2001, 1.6313D)) ;
    dataset.addData(0, createData(12, 11, 2001, 1.6272D)) ;
    dataset.addData(0, createData(13, 11, 2001, 1.6361000000000001D)) ;
    dataset.addData(0, createData(14, 11, 2001, 1.6323000000000001D)) ;
    dataset.addData(0, createData(15, 11, 2001, 1.6252D)) ;
    dataset.addData(0, createData(16, 11, 2001, 1.6141000000000001D)) ;
    dataset.addData(0, createData(19, 11, 2001, 1.6086D)) ;
    dataset.addData(0, createData(20, 11, 2001, 1.6054999999999999D)) ;
    dataset.addData(0, createData(21, 11, 2001, 1.6132D)) ;
    dataset.addData(0, createData(22, 11, 2001, 1.6073999999999999D)) ;
    dataset.addData(0, createData(23, 11, 2001, 1.6065D)) ;
    dataset.addData(0, createData(26, 11, 2001, 1.6061000000000001D)) ;
    dataset.addData(0, createData(27, 11, 2001, 1.6039000000000001D)) ;
    dataset.addData(0, createData(28, 11, 2001, 1.6069D)) ;
    dataset.addData(0, createData(29, 11, 2001, 1.6044D)) ;
    dataset.addData(0, createData(30, 11, 2001, 1.5928D)) ;

    int cols = dataset.getColumnCount() ;
    List datas = new ArrayList() ;
    for (int i = 0 ; i < cols ; i++) {
      datas.add(dataset.getData(0, i)) ;
    }

    XYNumberChartData[] averages = DatasetUtil.calculateDateMovingAverageDatas(datas, 30, 30) ;
    dataset.addRowKey("30 day moving average") ;
    dataset.addRowData() ;
    dataset.addDatas(1, averages) ;

    return dataset ;
  }

  private static XYNumberChartData createData(int day, int month, int year, double value) {
    return new XYNumberChartData(DateUtil.dateToTimeInMillis(year, month, day), value) ;
  }

}
