package demo.xycharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.AxisLabelType ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.constant.XYValueAxisType ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYSeriesDemo1 extends JPanel {

  public XYSeriesDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "XY Series Demo", "X", "Y", dataset, ChartOrientation.VERTICAL, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setRowItemShapeVisible(0, false) ;

    XYNumberValueAxis xAxis = new XYNumberValueAxis("X", dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_X, false) ;
    xAxis.setAxisLabelType(AxisLabelType.COLUMN) ;
    xAxis.setAxisRangeIncludeZero(false) ;
    xAxis.setAxisLabelVisible(false) ;

    XYNumberValueAxis yAxis = new XYNumberValueAxis("Y", dataset,
                                                    XYValueAxisType.XY_VALUE_AXIS_Y, false) ;
    yAxis.setValueLineVisible(true) ;
    yAxis.setAxisRangeIncludeZero(false) ;
    yAxis.setAxisLabelAngle(IAngle.ANGLE_UP_90) ;

    plot.setDomainAxis(1, xAxis) ;
    plot.setValueAxis(1, yAxis) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    dataset.addRowData() ;
    dataset.addRowKey("Random Data") ;

    dataset.addData(0, new XYNumberChartData(1.0D, 500.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 694.10000000000002D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 100D)) ;
    dataset.addData(0, new XYNumberChartData(12.5D, 734.39999999999998D)) ;
    dataset.addData(0, new XYNumberChartData(17.300000000000001D, 453.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(21.199999999999999D, 500.19999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(21.899999999999999D, Double.NaN)) ;
    dataset.addData(0, new XYNumberChartData(25.600000000000001D, 734.39999999999998D)) ;
    dataset.addData(0, new XYNumberChartData(30D, 453.19999999999999D)) ;

    return dataset ;
  }

}
