package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڵĵλ.</zh>
 * <en>Defines tokens used to indicate a date tick unit type.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class DateTickUnitType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 289427819776247268L ;

  /**
   * <zh>.</zh>
   * <en>A constant for milliseconds. </en>
   */
  public static final DateTickUnitType DATE_UNIT_MILLISECOND = new DateTickUnitType(
    "DateTickUnitType.MILLISECOND") ;

  /**
   * <zh>.</zh>
   * <en>A constant for seconds. </en>
   */
  public static final DateTickUnitType DATE_UNIT_SECOND = new DateTickUnitType(
    "DateTickUnitType.SECOND") ;

  /**
   * <zh>.</zh>
   * <en>A constant for minutes.</en>
   */
  public static final DateTickUnitType DATE_UNIT_MINUTE = new DateTickUnitType(
    "DateTickUnitType.MINUTE") ;

  /**
   * <zh>Сʱ.</zh>
   * <en>A constant for hours.</en>
   */
  public static final DateTickUnitType DATE_UNIT_HOUR = new DateTickUnitType(
    "DateTickUnitType.HOUR") ;

  /**
   * <zh>.</zh>
   * <en>A constant for days.</en>
   */
  public static final DateTickUnitType DATE_UNIT_DAY = new DateTickUnitType("DateTickUnitType.DAY") ;

  /**
   * <zh>·.</zh>
   * <en>A constant for months.</en>
   */
  public static final DateTickUnitType DATE_UNIT_MONTH = new DateTickUnitType(
    "DateTickUnitType.MONTH") ;

  /**
   * <zh>.</zh>
   * <en>A constant for years.</en>
   */
  public static final DateTickUnitType DATE_UNIT_YEAR = new DateTickUnitType(
    "DateTickUnitType.YEAR") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private DateTickUnitType(String name) {
    this.name = name ;
  }

  /**
   * <zh>¼.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return <zh>¼.</zh>
   * <en>The string.</en>
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>ʵǷ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param obj <zh>ҪȽϵĶ (Ϊnull).</zh>
   * <en>The object (null permitted).</en>
   *
   * @return A boolean.
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }
    if (!(obj instanceof DateTickUnitType)) {
      return false ;
    }

    DateTickUnitType that = (DateTickUnitType) obj ;
    return this.name.equals(that.name) ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return <zh>hascodeֵ.</zh>
   * <en>The hashcode.</en>
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }
}
