package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>һͼжrenderʱ,renderĻ˳..</zh>
 * <en>When there are multiple render in a chart,this constants are uses to control
 * the drawing order. Sequence and the reverse is two.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class RenderDrawOrder implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 1485893457559202795L ;

  /**
   * <zh>0,1,2,...,N-1˳render,Nrenderĸ.</zh>
   * <en>Call renders in the order 0, 1, 2, ..., N-1, where N is the number of renders.</en>
   */
  public static final RenderDrawOrder FORWARD = new RenderDrawOrder("RenderDrawOrder.FORWARD") ;

  /**
   * <zh>N-1,N-2,...,2,1,0˳render,Nrenderĸ.</zh>
   * <en>Call renders in the order N-1, N-2, ..., 2, 1, 0, where N is the number of renders.</en>
   */
  public static final RenderDrawOrder REVERSE = new RenderDrawOrder("RenderDrawOrder.REVERSE") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name String <zh>.</zh>
   * <en>The name.</en>
   */
  private RenderDrawOrder(String name) {
    this.name = name ;
  }

  /**
   * <zh>toString.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return <zh> (Ϊnull).</zh>
   * <en>The string (never null).</en>
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified
   * object, and false otherwise.</en>
   *
   * @param o  The other object.
   *
   * @return A boolean.
   */
  public boolean equals(Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof RenderDrawOrder)) {
      return false ;
    }

    RenderDrawOrder that = (RenderDrawOrder) o ;
    if (!this.name.equals(that.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>has hcodeֵ.</zh>
   * <en>Returns a hash code value for the object.  </en>
   * @return  a hash code value for this object.
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }

}
