package com.ijchart.xychart.constant ;

import java.io.Serializable ;

import com.ijchart.xychart.util.HashcodeUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ֵƫ.</zh>
 * <en>The offset type of value axis.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class ValueAxisOffsetType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 5210969617482863607L ;

  /**
   * <zh>᲻ƫ</zh>
   * <en>No offset.</en>
   */
  public static final ValueAxisOffsetType OFFSET_TYPE_NONE = new ValueAxisOffsetType(
    "ValueAxisOffsetType.NONE") ;

  /**
   * <zh>ƫưĳ.</zh>
   * <en>Offset half category.</en>
   */
  public static final ValueAxisOffsetType OFFSET_TYPE_HALF_CATEGORY =
    new ValueAxisOffsetType("ValueAxisOffsetType.HALF_CATEGORY") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private ValueAxisOffsetType(String name) {
    this.name = name ;
  }

  /**
   * <zh></zh>
   * <en>Returns a string representing the object.</en>
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param o  the other object.
   * @return A boolean.
   */
  public boolean equals(Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof ValueAxisOffsetType)) {
      return false ;
    }

    ValueAxisOffsetType offsetType = (ValueAxisOffsetType) o ;
    if (!this.name.equals(offsetType.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object</en>
   *
   * @return int <zh>hashcodeֵ.</zh>
   * <en>A hash code value for this object.</en>
   */
  public int hashCode() {
    return HashcodeUtil.hashCode(this.name) ;
  }

}
